orders = new.tableRef("orders", "PostgreSQL", "postgre.config", "tpch")
lineitem = new.tableRef("lineitem", "PostgreSQL", "postgre.config", "tpch")
q =
order(function(x) c(x$l_shipmode), function(x) c(TRUE),
group(function(x) c(x$l_shipmode),
select(function(x){
  y = new.env()
  y$l_shipmode = x$l_shipmode
  y$high_line_count = sum(if (x$o_orderpriority == "1-URGENT" || x$o_orderpriority == "2-HIGH") 1 else 0)
  y$low_line_count = sum(if (x$o_orderpriority != "1-URGENT" && x$o_orderpriority != "2-HIGH") 1 else 0)
  y
},
where(function(x) (x$l_shipmode == "MAIL" || x$l_shipmode == "SHIP")
  && x$l_commitdate < x$l_receiptdate && x$l_shipdate < x$l_commitdate
  && x$l_receiptdate >= date("1994-01-01")
  && x$l_receiptdate < date("1994-01-01") + interval(1, "year"),
join(from(orders),
     from(lineitem),
     function(x, y) x$o_orderkey == y$l_orderkey)))))
print(query.force(q))
